package StreamSimulator.Buffer;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import java.util.*;

import StreamSimulator.StreamJoin.StreamJoin;

public class BufferTuple implements Comparable {

  public long timestamp;
  public double credit;
  public int[] value;
  public int stream_ID;
  static public int NEW_ARRIVAL=1;
  static public int OLD_TUPLE = 0;
  public int stat;

  public BufferTuple(long t, double credit, int stream_ID, int[] val) {
    this.timestamp = t;
    this.credit = credit;
    this.value = new int[StreamJoin.NUM_ATTRIBUTE];
    for (int i=0;i<StreamJoin.NUM_ATTRIBUTE;i++)
      this.value[i] = val[i];
    this.stream_ID = stream_ID;
    this.stat = this.NEW_ARRIVAL;
  }

  public int compareTo(Object obj)
  {
    BufferTuple tuple = (BufferTuple)obj;
    int res=0;
    if (this.credit<tuple.credit)
      res = 1;
    else if (this.credit == tuple.credit)
      res = 0;
    else if (this.credit > tuple.credit)
      res = -1;
    return res;
  }
}
