package StreamSimulator.StreamGenerator;

import java.lang.String;
import java.io.*;
import StreamSimulator.Buffer.*;
import java.util.*;
import StreamSimulator.StreamJoin.StreamJoin;

public class StockDataGenerator extends StreamGenerator {
  FileReader wcFile;
  BufferedReader bfWC;

  public StockDataGenerator(String file, long seed) {
    super(seed);
    try
    {
      this.wcFile = new FileReader(file);
      this.bfWC = new BufferedReader(wcFile);
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try {
      bfWC.mark(300);
      nextLine = bfWC.readLine();
      if (nextLine != null)
      {
      	StringTokenizer tok = new StringTokenizer(nextLine);
      	
        String strobjID = tok.nextToken();
        int objID = Integer.parseInt(strobjID);

        String ipaddress = tok.nextToken();
        int data = Integer.parseInt(ipaddress);
        int t = Integer.parseInt(ipaddress);

		//System.out.println(data + " " + objID);

        //System.out.println("WC GEN:"+integerTime.intValue()+" "+data+" "+this.timeStamp+" "+objID+" "+serverID);
        if (t < this.timeStamp+StreamJoin.UNIT)
        {
          Vector v = new Vector();
          //System.out.println(data);
          //v.add(new Integer(data));
          v.add(new Integer(objID));
          
          //v.add(new Integer(serverID));
          return v;
        }
        else {
          bfWC.reset();
          return null;
        }
      }
      else
        return null;
    }
    catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }


}
