package StreamSimulator.Buffer;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import StreamSimulator.Stream.*;

public interface StreamBuffer {
  public boolean insert(BufferTuple tuple);
  public void drop(Topology top);
  public long[] join(BufferTuple tuple, Topology top);
  public void validateBuffer(long tstart, int tend);
}
