package StreamSimulator.StreamGenerator;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import java.io.*;
import StreamSimulator.Buffer.*;
import java.util.*;

import StreamSimulator.StreamJoin.StreamJoin;

public class DataFileGenerator extends StreamGenerator {
  FileReader dataFile;
  BufferedReader bfData;

  public DataFileGenerator(String file, long seed) {
    super(seed);
    try
    {
      this.dataFile = new FileReader(file);
      this.bfData = new BufferedReader(dataFile);
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try
    {
      bfData.mark(300);
      nextLine = bfData.readLine();
      Vector v = new Vector();
      if (nextLine != null)
      {
        int index = nextLine.indexOf(',');
        String time = nextLine.substring(0, index);
        Integer integerTime = new Integer(time);
        if (integerTime.intValue() == this.timeStamp)
        {
          int nextIndex = index;
          for (int i = 0; i < StreamJoin.NUM_ATTRIBUTE; i++) {
            nextIndex = nextLine.indexOf(',', index + 1);
            String strData = nextLine.substring(index + 1, nextIndex);
            Integer data = new Integer(strData);
            v.add(data);
            index = nextIndex;
          }
          return v;
        }
        else {
          bfData.reset();
          return null;
        }
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
      return null;
    }
    return null;
  }
}
