package StreamSimulator.StreamGenerator;

import java.lang.String;
import java.io.*;
import StreamSimulator.Buffer.*;
import java.util.*;
import StreamSimulator.StreamJoin.StreamJoin;


public class GismoGenerator extends StreamGenerator {
  FileReader wcFile;
  BufferedReader bfWC;

  public GismoGenerator(String file, long seed) {
    super(seed);
    try
    {
      this.wcFile = new FileReader(file);
      this.bfWC = new BufferedReader(wcFile);
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try {
      bfWC.mark(300);
      nextLine = bfWC.readLine();
      if (nextLine != null)
      {
      	StringTokenizer tok = new StringTokenizer(nextLine);
      	
        String user = tok.nextToken();
        int data = Integer.parseInt(user);

        String time = tok.nextToken();
        int t = Integer.parseInt(time);

		int[] objID	= new int[tok.countTokens()];
		for(int i = 0; i < objID.length; i++) {
			String strobjID = tok.nextToken();
			objID[i] = Integer.parseInt(strobjID);
		}

        //System.out.println("WC GEN:"+integerTime.intValue()+" "+data+" "+this.timeStamp+" "+objID+" "+serverID);
        if (t < this.timeStamp+StreamJoin.UNIT)
        {
          Vector v = new Vector();
			
		  for(int i = 0; i<objID.length; i++)
	        v.add(new Integer(objID[i]));

          return v;
        }
        else {
          bfWC.reset();
          return null;
        }
      }
      else
        return null;
    }
    catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }


}
